package opti;
import java.awt.*;

 /**
 *  <h4>Antrieb.java  - simulation-model of an electro-car as PT2-unit.</h4>
 *  <br/>
 *  <h4>Antrieb.java  - Simulationsmodell eines Elektroantriebs als PT2-bertragungsglied.</h4>
 *  <br/>
 *  Copyright (C) 2011 Guido Kramann<br/>
 *  kramann@fh-brandenburg.de<br/>
 *  http://www.kramann.info<br/>
 *  <br/>
 *  <p>  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  </p>
 *  <p>
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *  </p>
 *  <p>
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  </p>
 */

public class Antrieb extends Simulationsmodell
{
    /**
    Die folgenden Variablen sind die Modellparameter, die spter
    optimiert werden knnen.<br/>
    Als Startwert sind die zu erwartenden Extremwerte eingestellt, damit
    spter automatisiert GUI-Elemente erzeugt werden knnen.<br/>
    Da positive Extremwerte vorgegeben sind, ist damit festgelegt, dass
    alle Modell-Parameter nicht negativ werden drfen.
    */

//ACHTUNG: K und L sind gegenber Scilab-Musterlsung vertauscht!
    public double K = 100000.0;
    public double L = 100000.0;
    public double M = 100000.0;

    public double pwm = -1023.0;

    public Antrieb()
    {
        super(2); //Zwei Simulationsgleichungen
    }

    public double[] berechneRechteSeite(double[] yalt, double t)
    {
        double m = 1.0;
        double r = 0.5;
        double d = 0.05;
        double g = 9.81;
        
        double J = 0.25*m*(0.5*d)*(0.5*d)+(1.0/12.0)*m*(2.0*r)*(2.0*r);

        double FA = 0.0;

        /**Eigentliche Bestimmung der rechten Seite (Steigungsvektor)*/
        f[0] = yalt[1];
        f[1] = - (( m*r*g )/(J+m*r*r))*Math.sin(yalt[0]) + ((2.0*r)/(J+m*r*r))*Math.cos(yalt[0])*FA ;
        return f;
    } 

    /** paint(..) wird bei der Konsolenanwendung nicht verwendet.*/
    public void paint(Graphics2D g)
    {
    }
}